#!/bin/sh

# MTD device name	Device offset	Env. size	Flash sector size	Number of sectors
#/dev/mtd0		0xc0000		0x20000		0x20000

#backing up current config
mv /etc/fw_env.config /etc/fw_env.config.backup

#list of block addresses
#128k = 131072 bytes -> 0x20000 in hexadecimal and we sum 0x20000 to it to get our addresses.

# address=180000
#
# while [ "$address" != "0" ] ; do
#
# address=$( echo "obase=16;ibase=16;$address-20000" | bc )
# echo $address
#
# done


# addresses for mtd0 (2 MB)

# 0x1E0000
# 0x1C0000
# 0x1A0000
# 0x180000
# 0x160000
# 0x140000
# 0x120000
# 100000
# E0000
# C0000
# A0000
# 80000
# 60000
# 40000
# 20000
# 0

# addresses for mtd1
# same as above, it restarts from 0 in each mtd

#zyxel nsa310 new mtdparts, kinda
#mtdparts=orion_nand:0x100000(uboot),0x80000(uboot_env),0x100000(second_stage_uboot),0x7b80000(ubi)

for address in e0000 c0000 a0000 80000 60000 40000 20000 0; do

echo "/dev/mtd0		0x$address		0x20000		0x20000" > /etc/fw_env.config
cat /etc/fw_env.config
echo "stuff found at mtd0 $address"
fw_printenv
echo -----------------------------

done

for address in 1e0000 1c0000 1a0000 180000 160000 140000 120000 100000 e0000 c0000 a0000 80000 60000 40000 20000 0; do

echo "/dev/mtd1		0x$address		0x20000		0x20000" > /etc/fw_env.config

echo "stuff found at mtd1 $address"
fw_printenv
echo -----------------------------

done

#restoring current config
mv /etc/fw_env.config.backup /etc/fw_env.config
